diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/cityturn.c freeciv-patched/server/cityturn.c
--- freeciv-cvs/server/cityturn.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/server/cityturn.c	2003-06-30 12:18:17.000000000 +0100
@@ -369,10 +369,8 @@
       }
     }
 
-    can_grow = (city_got_building(pcity, B_AQUEDUCT)
-		|| pcity->size < game.aqueduct_size)
-      && (city_got_building(pcity, B_SEWER)
-	  || pcity->size < game.sewer_size);
+    can_grow = (pcity->size_limit < 0
+                || pcity->size < pcity->size_limit);
 
     if ((turns_growth <= 0) && !city_celebrating(pcity) && can_grow) {
       notify_conn_ex(dest, pcity->x, pcity->y,
@@ -402,16 +400,36 @@
 }
 
 /**************************************************************************
+  N.B. We call update_tech for the total science output, rather than for
+  each city individually, to reduce rounding error when applying science
+  bonuses.
+***************************************************************************/
+static void update_all_tech(struct player *pplayer)
+{
+  int current_output = total_science_output(pplayer);
+
+  update_tech(pplayer, current_output);
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 void update_city_activities(struct player *pplayer)
 {
-  int gold;
+  int gold, goldmade;
   gold=pplayer->economic.gold;
   pplayer->got_tech = FALSE;
   city_list_iterate(pplayer->cities, pcity)
      update_city_activity(pplayer, pcity);
   city_list_iterate_end;
+
+  /* Apply impr. gen. global tax bonuses */
+  goldmade = pplayer->economic.gold - gold;
+  goldmade = goldmade * pplayer->tax_bonus / 100;
+  goldmade = goldmade * game.tax_bonus / 100;
+  pplayer->economic.gold = gold + goldmade;
+
+  update_all_tech(pplayer);
   pplayer->ai.prev_gold = gold;
   if (gold-(gold-pplayer->economic.gold)*3<0) {
     notify_player_ex(pplayer, -1, -1, E_LOW_ON_FUNDS,
@@ -471,44 +489,26 @@
 {
   struct player *powner = city_owner(pcity);
   bool have_square;
-  bool has_granary = city_got_effect(pcity, B_GRANARY);
   bool rapture_grow = city_rapture_grow(pcity); /* check before size increase! */
   int new_food;
 
-  if (!city_got_building(pcity, B_AQUEDUCT)
-      && pcity->size>=game.aqueduct_size) {/* need aqueduct */
-    if (!pcity->is_building_unit && pcity->currently_building == B_AQUEDUCT) {
+  /* Check for needed aqueduct/sewer system/etc. */
+  if (pcity->size_limit >= 0 && pcity->size >= pcity->size_limit) {
+    if (!pcity->is_building_unit
+        && pcity->currently_building == pcity->unlimit_impr) {
       notify_player_ex(powner, pcity->x, pcity->y, E_CITY_AQ_BUILDING,
 		       _("Game: %s needs %s (being built) "
 			 "to grow any further."), pcity->name,
-		       improvement_types[B_AQUEDUCT].name);
+		       get_improvement_name(pcity->unlimit_impr));
     } else {
       notify_player_ex(powner, pcity->x, pcity->y, E_CITY_AQUEDUCT,
 		       _("Game: %s needs %s to grow any further."),
-		       pcity->name, improvement_types[B_AQUEDUCT].name);
+		       pcity->name, get_improvement_name(pcity->unlimit_impr));
     }
     /* Granary can only hold so much */
     new_food = (city_granary_size(pcity->size) *
-		(100 - game.aqueductloss / (1 + (has_granary ? 1 : 0)))) / 100;
-    pcity->food_stock = MIN(pcity->food_stock, new_food);
-    return;
-  }
-
-  if (!city_got_building(pcity, B_SEWER)
-      && pcity->size>=game.sewer_size) {/* need sewer */
-    if (!pcity->is_building_unit && pcity->currently_building == B_SEWER) {
-      notify_player_ex(powner, pcity->x, pcity->y, E_CITY_AQ_BUILDING,
-		       _("Game: %s needs %s (being built) "
-			 "to grow any further."), pcity->name,
-		       improvement_types[B_SEWER].name);
-    } else {
-      notify_player_ex(powner, pcity->x, pcity->y, E_CITY_AQUEDUCT,
-		       _("Game: %s needs %s to grow any further."),
-		       pcity->name, improvement_types[B_SEWER].name);
-    }
-    /* Granary can only hold so much */
-    new_food = (city_granary_size(pcity->size) *
-		(100 - game.aqueductloss / (1 + (has_granary ? 1 : 0)))) / 100;
+		(100 - game.aqueductloss *
+		 (100 - pcity->growth_food) / 100)) / 100;
     pcity->food_stock = MIN(pcity->food_stock, new_food);
     return;
   }
@@ -518,10 +518,7 @@
   if (rapture_grow) {
     new_food = city_granary_size(pcity->size);
   } else {
-    if (has_granary)
-      new_food = city_granary_size(pcity->size) / 2;
-    else
-      new_food = 0;
+    new_food = city_granary_size(pcity->size) * pcity->growth_food / 100;
   }
   pcity->food_stock = MIN(pcity->food_stock, new_food);
 
@@ -588,10 +585,8 @@
 			 pcity->name, utname);
 	gamelog(GAMELOG_UNITFS, _("%s lose %s (famine)"),
 		get_nation_name_plural(city_owner(pcity)->nation), utname);
-	if (city_got_effect(pcity, B_GRANARY))
-	  pcity->food_stock=city_granary_size(pcity->size)/2;
-	else
-	  pcity->food_stock=0;
+	pcity->food_stock = city_granary_size(pcity->size) *
+			    pcity->growth_food / 100;
 	return;
       }
     }
@@ -599,10 +594,8 @@
     notify_player_ex(city_owner(pcity), pcity->x, pcity->y, E_CITY_FAMINE,
 		     _("Game: Famine causes population loss in %s."),
 		     pcity->name);
-    if (city_got_effect(pcity, B_GRANARY))
-      pcity->food_stock = city_granary_size(pcity->size - 1) / 2;
-    else
-      pcity->food_stock = 0;
+    pcity->food_stock = city_granary_size(pcity->size - 1) *
+			pcity->growth_food / 100;
     city_reduce_size(pcity, 1);
   }
 }
@@ -912,11 +905,47 @@
 }
 
 /**************************************************************************
+  Gives immediate tech advances if we've just built a city improvement
+  that confers the Give_Imm_Adv effect (e.g. Darwin's Voyage)
+**************************************************************************/
+static void check_boost_research(struct city *pcity, struct player *pplayer)
+{
+  int numadv = 0;
+
+  impr_effects_iterate(iter, B_LAST, pcity, NULL) {
+    if (iter.imeff->type == EFT_GIVE_IMM_ADV
+        && eff_iterator_get_improvement(&iter) == pcity->currently_building) {
+      numadv = iter.imeff->amount;
+      break;
+    }
+  } impr_effects_iterate_end;
+
+  if (numadv) {
+    notify_player(pplayer, PL_("Game: %s boosts research; you gain %d "
+		  "immediate advance.", "Game: %s boosts research; you "
+		  "gain %d immediate advances.", numadv),
+		    get_improvement_name(pcity->currently_building),
+		    numadv);
+    while (numadv) {
+      do_free_cost(pplayer);
+      notify_embassies(pplayer, NULL,
+          	       _("Game: The %s have acquired %s from %s."),
+                       get_nation_name_plural(pplayer->nation),
+                       get_tech_name(pplayer, pplayer->research.researching),
+                       get_improvement_name(pcity->currently_building));
+      found_new_tech(pplayer, pplayer->research.researching, TRUE, TRUE);
+      numadv--;
+    }
+  }
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 static bool city_build_building(struct player *pplayer, struct city *pcity)
 {
   bool space_part;
+  int imp_value;
 
   if (pcity->currently_building == B_CAPITAL) {
     assert(pcity->shield_surplus >= 0);
@@ -936,11 +965,13 @@
 						   currently_building));
     return TRUE;
   }
-  if (pcity->shield_stock >= improvement_value(pcity->currently_building)) {
+
+  imp_value = improvement_value_adjusted(pcity->currently_building, pcity);
+  if (pcity->shield_stock >= imp_value) {
     if (pcity->currently_building == B_PALACE) {
       city_list_iterate(pplayer->cities, palace)
 	  if (city_got_building(palace, B_PALACE)) {
-	city_remove_improvement(palace, B_PALACE);
+	city_remove_improvement(palace, B_PALACE, FALSE);
 	break;
       }
       city_list_iterate_end;
@@ -957,9 +988,8 @@
       space_part = FALSE;
       city_add_improvement(pcity, pcity->currently_building);
     }
-    pcity->before_change_shields -=
-	improvement_value(pcity->currently_building);
-    pcity->shield_stock -= improvement_value(pcity->currently_building);
+    pcity->before_change_shields -= imp_value;
+    pcity->shield_stock -= imp_value;
     pcity->turn_last_built = game.year;
     /* to eliminate micromanagement */
     if (is_wonder(pcity->currently_building)) {
@@ -984,31 +1014,8 @@
 		     _("Game: %s has finished building %s."), pcity->name,
 		     improvement_types[pcity->currently_building].name);
 
-    if (pcity->currently_building == B_DARWIN) {
-      Tech_Type_id first, second;
-      char buffer[200];
-
-      notify_player(pplayer, _("Game: %s boosts research, "
-			       "you gain 2 immediate advances."),
-		    improvement_types[B_DARWIN].name);
+    check_boost_research(pcity, pplayer);
 
-      do_free_cost(pplayer);
-      first = pplayer->research.researching;
-      found_new_tech(pplayer, pplayer->research.researching, TRUE, TRUE);
-
-      do_free_cost(pplayer);
-      second = pplayer->research.researching;
-      found_new_tech(pplayer, pplayer->research.researching, TRUE, TRUE);
-
-      (void) mystrlcpy(buffer, get_tech_name(pplayer, first),
-		       sizeof(buffer));
-
-      notify_embassies(pplayer, NULL,
-		       _("Game: The %s have acquired %s and %s from %s."),
-		       get_nation_name_plural(pplayer->nation), buffer,
-		       get_tech_name(pplayer, second),
-		       improvement_types[B_DARWIN].name);
-    }
     if (space_part && pplayer->spaceship.state == SSHIP_NONE) {
       notify_player_ex(NULL, pcity->x, pcity->y, E_SPACESHIP,
 		       _("Game: The %s have started "
@@ -1042,9 +1049,13 @@
 **************************************************************************/
 static bool city_build_unit(struct player *pplayer, struct city *pcity)
 {
+  int unit_val;
+
   upgrade_unit_prod(pcity);
 
-  if (pcity->shield_stock >= unit_value(pcity->currently_building)) {
+  unit_val = unit_value_adjusted(pcity->currently_building, pcity);
+
+  if (pcity->shield_stock >= unit_val) {
     int pop_cost = unit_pop_value(pcity->currently_building);
 
     /* Should we disband the city? -- Massimo */
@@ -1077,8 +1088,8 @@
 
     /* to eliminate micromanagement, we only subtract the unit's
        cost */
-    pcity->before_change_shields -= unit_value(pcity->currently_building);
-    pcity->shield_stock -= unit_value(pcity->currently_building);
+    pcity->before_change_shields -= unit_val;
+    pcity->shield_stock -= unit_val;
 
     notify_player_ex(pplayer, pcity->x, pcity->y, E_UNIT_BUILD,
 		     _("Game: %s is finished building %s."),
@@ -1320,11 +1331,6 @@
 
     pcity->did_sell=FALSE;
     pcity->did_buy = FALSE;
-    if (city_got_building(pcity, B_AIRPORT))
-      pcity->airlift=TRUE;
-    else
-      pcity->airlift=FALSE;
-    update_tech(pplayer, pcity->science_total);
     pplayer->economic.gold+=pcity->tax_total;
     pay_for_buildings(pplayer, pcity);
 
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/diplomats.c freeciv-patched/server/diplomats.c
--- freeciv-cvs/server/diplomats.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/server/diplomats.c	2003-06-30 12:17:26.000000000 +0100
@@ -827,7 +827,8 @@
   - Check for infiltration success.  Our saboteur may not survive this.
   - Check for basic success.  Again, our saboteur may not survive this.
   - Determine target, given arguments and constraints.
-  - If specified, city walls and anything in a capital are 50% likely to fail.
+  - If specified, city walls and anything in a capital are 50% likely to
+    fail (with default rulesets, due to Spy_Resistant improvement effects).
   - Do sabotage!
 
   - The saboteur may be captured and executed, or escape to its home town.
@@ -838,7 +839,6 @@
   struct player *cplayer;
   int count, which, target;
   const char *prod;
-  struct city *capital;
 
   /* Fetch target city's player.  Sanity checks. */
   if (!pcity)
@@ -992,12 +992,19 @@
 
     /*
      * One last chance to get caught:
-     * If target was specified, and it is in the capital or are
-     * City Walls, then there is a 50% chance of getting caught.
+     * If target was specified, we check for any active Spy_Resistant
+     * effects (e.g. from the Palace or City Walls) which define the
+     * chance of getting caught.
      */
-    capital = find_palace (city_owner (pcity));
-    if ((pcity == capital) || (improvement == B_CITY)) {
-      if (myrand (2) == 1) {
+    if (improvement >= 0 && improvement != B_LAST) {
+      int failchance = 0;
+      impr_effects_iterate(iter, improvement, pcity, cplayer) {
+        if (iter.imeff->type == EFT_SPY_RESISTANT) {
+          failchance += iter.imeff->amount;
+        }
+      } impr_effects_iterate_end;
+
+      if (myrand(100) < failchance) {
 	/* Caught! */
 	notify_player_ex(pplayer, pcity->x, pcity->y, E_MY_DIPLOMAT_FAILED,
 			 _("Game: Your %s was caught in the attempt"
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/gamehand.c freeciv-patched/server/gamehand.c
--- freeciv-cvs/server/gamehand.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/server/gamehand.c	2003-06-30 12:17:47.000000000 +0100
@@ -154,6 +154,12 @@
 
   /* Initialise list of improvements with world-wide equiv_range */
   improvement_status_init(game.improvements, ARRAY_SIZE(game.improvements));
+
+  /* Free vector of effects with world-wide range. */
+  geff_vector_free(&game.effects);
+
+  /* Free vector of destroyed effects */
+  ceff_vector_free(&game.destroyed_effects);
 }
 
 /**************************************************************************
@@ -242,6 +248,10 @@
     ginfo.global_advances[i] = game.global_advances[i];
   for (i = 0; i < B_LAST /*game.num_impr_types */ ; i++)
     ginfo.global_wonders[i] = game.global_wonders[i];
+  for (i = 0; i < B_LAST; i++) {
+    ginfo.destroyed_owner[i] = game.destroyed_owner[i] ?
+                               game.destroyed_owner[i]->player_no : -1;
+  }
   /* the following values are computed every
      time a packet_game_info packet is created */
   if (game.timeout != 0) {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/gotohand.c freeciv-patched/server/gotohand.c
--- freeciv-cvs/server/gotohand.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/server/gotohand.c	2003-06-30 12:17:19.000000000 +0100
@@ -705,8 +705,7 @@
 	    && !same_pos(x1, y1, dest_x, dest_y)) {
 	  continue;
 	}
-	else if (unit_flag(punit, F_TRIREME)
-		 && trireme_loss_pct(unit_owner(punit), x1, y1) > 0) {
+	else if (ship_loss_pct(punit, x1, y1) > 0) {
 	  move_cost = 2*SINGLE_MOVE+1;
 	} else {
 	  move_cost = SINGLE_MOVE;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/plrhand.c freeciv-patched/server/plrhand.c
--- freeciv-cvs/server/plrhand.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/server/plrhand.c	2003-06-30 12:18:03.000000000 +0100
@@ -120,34 +120,41 @@
 }
 
 /**************************************************************************
-...
+  Grants techs that other players have researched, as a result of owning
+  an active Great Library Wonder, or other building that confers the
+  Adv_Parasite effect
 **************************************************************************/
 void great_library(struct player *pplayer)
 {
-  int i;
-  if (wonder_obsolete(B_GREAT)) 
-    return;
-  if (find_city_wonder(B_GREAT)) {
-    if (pplayer->player_no==find_city_wonder(B_GREAT)->owner) {
-      for (i=0;i<game.num_tech_types;i++) {
-	if (get_invention(pplayer, i) != TECH_KNOWN
-	    && tech_is_available(pplayer, i)
-	    && game.global_advances[i]>=2) {
-	  notify_player_ex(pplayer, -1, -1, E_TECH_GAIN,
-			   _("Game: %s acquired from The Great Library!"),
-			   advances[i].name);
-	  gamelog(GAMELOG_TECH, _("%s discover %s (Library)"),
-		  get_nation_name_plural(pplayer->nation), advances[i].name);
-	  notify_embassies(pplayer, NULL,
-			   _("Game: The %s have acquired %s"
-			     " from the Great Library."),
-			   get_nation_name_plural(pplayer->nation),
-			   advances[i].name);
-
-	  do_free_cost(pplayer);
-	  found_new_tech(pplayer, i, FALSE, FALSE);
-	  break;
-	}
+  int i, playreq = 0;
+  Impr_Type_id impr = B_LAST;
+
+  impr_effects_iterate(iter, B_LAST, NULL, pplayer) {
+    if (iter.imeff->type == EFT_ADV_PARASITE
+	&& (playreq == 0 || iter.imeff->amount < playreq)) {
+      playreq = iter.imeff->amount;
+      impr = eff_iterator_get_improvement(&iter);
+    }
+  } impr_effects_iterate_end;
+
+  if (playreq > 0 && impr != B_LAST) {
+    for (i = 0; i < game.num_tech_types; i++) {
+      if (get_invention(pplayer, i) != TECH_KNOWN 
+	  && tech_is_available(pplayer, i)
+	  && game.global_advances[i] >= playreq) {
+	notify_player_ex(pplayer, -1, -1, E_TECH_GAIN,
+			 _("Game: %s acquired from %s!"),
+			 advances[i].name, get_improvement_name(impr));
+	gamelog(GAMELOG_TECH, _("%s discover %s (Library)"),
+		get_nation_name_plural(pplayer->nation), advances[i].name);
+	notify_embassies(pplayer, NULL,
+			 _("Game: The %s have acquired %s from %s."),
+			 get_nation_name_plural(pplayer->nation),
+			 advances[i].name, get_improvement_name(impr));
+
+	do_free_cost(pplayer);
+	found_new_tech(pplayer, i, FALSE, FALSE);
+	break;
       }
     }
   }
@@ -172,6 +179,34 @@
 }
 
 /**************************************************************************
+  Called when a player is eliminated; moves all of the player's destroyed
+  effects to the global destroyed effects list.
+**************************************************************************/
+static void handle_player_destroyed_effects(struct player *pplayer)
+{
+  struct eff_city *plrceff, *gameceff;
+  struct ceff_vector *plrceffs, *gameceffs;
+  int i, needupdate = FALSE;
+
+  plrceffs  = &pplayer->destroyed_effects;
+  gameceffs = &game.destroyed_effects;
+
+  for (i = 0; i < ceff_vector_size(plrceffs); ++i) {
+    plrceff = ceff_vector_get(plrceffs, i);
+    if (plrceff->impr < B_LAST) {
+      gameceff = append_ceff(gameceffs);
+      gameceff->impr = plrceff->impr;
+      gameceff->active = 0;
+      needupdate = TRUE;
+      freelog(LOG_DEBUG, "Effects of %s moved to global destroyed effects list",
+              get_improvement_name(plrceff->impr));
+      game.destroyed_owner[plrceff->impr] = NULL;
+    }
+  }
+  if (needupdate) update_all_effects();
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 void update_player_aliveness(struct player *pplayer)
@@ -183,6 +218,7 @@
       notify_player_ex(pplayer, -1, -1, E_GAME_END,
 		       _("Game: You are dead!"));
       pplayer->is_alive = FALSE;
+      handle_player_destroyed_effects(pplayer);
       if( !is_barbarian(pplayer) ) {
 	notify_player_ex(NULL, -1, -1, E_DESTROYED,
 			 _("Game: The %s are no more!"),
@@ -738,6 +774,9 @@
   }
 
   check_player_government_rates(pplayer);
+  player_update_global_effects(pplayer);
+  update_all_effects();
+
   global_city_refresh(pplayer);
   send_player_info(pplayer, pplayer);
 }
@@ -763,8 +802,10 @@
   check_player_government_rates(pplayer);
   global_city_refresh(pplayer);
   send_player_info(pplayer, pplayer);
-  if (player_owns_active_govchange_wonder(pplayer))
-    pplayer->revolution=1;
+  /* Skip revolution period if we have the relevant effect */
+  impr_effects_iterate(iter, B_LAST, NULL, pplayer) {
+    if (iter.imeff->type == EFT_NO_ANARCHY) pplayer->revolution = 1;
+  } impr_effects_iterate_end;
 }
 
 /**************************************************************************
